tclap: TCLAP::Arg Class Reference

Main Page | Namespace List | Class Hierarchy | Class List | Directories | File List | Namespace Members | Class Members | File Members

# TCLAP::Arg Class Reference

A virtual base class that defines the essential data for all arguments. More...

`#include <Arg.h>`

Inheritance diagram for TCLAP::Arg:

[legend]
Collaboration diagram for TCLAP::Arg:

[legend]
List of all members.

## Public Member Functions
virtual | ~Arg ()
| Destructor.
virtual void | addToList (std::list< Arg * > &argList) const
| Overridden by Args that need to added to the end of the list.
virtual bool | processArg (int *i, std::vector< std::string > &args)=0
| Pure virtual method meant to handle the parsing and value assignment of the string on the command line.
virtual bool | operator== (const Arg &a) const
| Operator ==.
const std::string & | getFlag () const
| Returns the argument flag.
const std::string & | getName () const
| Returns the argument name.
std::string | getDescription () const
| Returns the argument description.
virtual bool | isRequired () const
| Indicates whether the argument is required.
void | forceRequired ()
| Sets _required to true.
void | xorSet ()
| Sets the _alreadySet value to true.
bool | isValueRequired () const
| Indicates whether a value must be specified for argument.
bool | isSet () const
| Indicates whether the argument has already been set.
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired.
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument.
virtual std::string | toString () const
| Returns a simple string representation of the argument.
virtual std::string | shortID (const std::string &valueId="val") const
| Returns a short ID for the usage.
virtual std::string | longID (const std::string &valueId="val") const
| Returns a long ID for the usage.
virtual void | trimFlag (std::string &flag, std::string &value) const
| Implementation of trimFlag.
bool | _hasBlanks (const std::string &s) const
| Implementation of _hasBlanks.
void | setRequireLabel (const std::string &s)
| Sets the requireLabel.
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set.
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values.
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines.
## Static Public Member Functions
void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified.
bool | ignoreRest ()
| Whether to ignore the rest.
char | delimiter ()
| The delimiter that separates an argument flag/name from the value.
char | blankChar ()
| The char used as a place holder when SwitchArgs are combined.
char | flagStartChar ()
| The char that indicates the beginning of a flag.
const std::string | flagStartString ()
| The sting that indicates the beginning of a flag.
const std::string | nameStartString ()
| The sting that indicates the beginning of a name.
const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument.
void | setDelimiter (char c)
| Sets the delimiter for all arguments.
## Protected Member Functions
void | _checkWithVisitor () const
| Performs the special handling described by the Vistitor.
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor.
## Protected Attributes
std::string | _flag
| The single char flag used to identify the argument.
std::string | _name
| A single work namd indentifying the argument.
std::string | _description
| Description of the argument.
bool | _required
| Indicating whether the argument is required.
std::string | _requireLabel
| Label to be used in usage description.
bool | _valueRequired
| Indicates whether a value is required for the argument.
bool | _alreadySet
| Indicates whether the argument has been set.
Visitor * | _visitor
| A pointer to a vistitor object.
bool | _ignoreable
| Whether this argument can be ignored, if desired.
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line.
bool | _acceptsMultipleValues

## Detailed Description

A virtual base class that defines the essential data for all arguments.

This class, or one of its existing children, must be subclassed to do anything.

Definition at line 64 of file Arg.h.

## Constructor & Destructor Documentation

TCLAP::Arg::Arg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | bool | valreq,
|  | Visitor * | v = `NULL`
| ) | `[inline, protected]`

  | Primary constructor. YOU (yes you) should NEVER construct an Arg directly, this is a base class that is extended by various children that are meant to be used. Use SwitchArg, ValueArg, MultiArg, UnlabeledValueArg, or UnlabeledMultiArg instead. Parameters:
  | flag | - The flag identifying the argument.
  | name | - The name identifying the argument.
  | desc | - The description of the argument, used in the usage.
  | req | - Whether the argument is required.
  | valreq | - Whether the a value is required for the argument.
  | v | - The visitor checked by the argument. Defaults to NULL.
Definition at line 442 of file Arg.h. References _flag, _name, ignoreNameString(), and toString().

Here is the call graph for this function:

TCLAP::Arg::~Arg | ( |  | ) | `[inline, virtual]`

| Destructor. Definition at line 483 of file Arg.h.

## Member Function Documentation

void TCLAP::Arg::_checkWithVisitor | ( |  | ) | const`[inline, protected]`

| Performs the special handling described by the Vistitor. Definition at line 591 of file Arg.h. References _visitor, and TCLAP::Visitor::visit(). Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiSwitchArg::processArg(), and TCLAP::MultiArg< T >::processArg().

Here is the call graph for this function:

bool TCLAP::Arg::_hasBlanks | ( | const std::string & | s | ) | const`[inline]`

  | Implementation of _hasBlanks. If so, return true, otherwise return false. Parameters:
  | s | - string to be checked.
Definition at line 621 of file Arg.h. Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::UnlabeledValueArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

bool TCLAP::Arg::acceptsMultipleValues | ( |  | ) | `[inline, virtual]`

| Use by output classes to determine whether an Arg accepts multiple values. Definition at line 654 of file Arg.h. Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

void TCLAP::Arg::addToList | ( | std::list< Arg * > & | argList | ) | const`[inline, virtual]`

  | Overridden by Args that need to added to the end of the list. Parameters:
  | argList | - The list to add this to.
Reimplemented in TCLAP::UnlabeledMultiArg< T >, and TCLAP::UnlabeledValueArg< T >. Definition at line 644 of file Arg.h. Referenced by TCLAP::CmdLine::add().

bool TCLAP::Arg::allowMore | ( |  | ) | `[inline, virtual]`

| Used for MultiArgs and XorHandler to determine whether args can still be set. Reimplemented in TCLAP::MultiArg< T >. Definition at line 649 of file Arg.h.

bool TCLAP::Arg::argMatches | ( | const std::string & | s | ) | const`[inline, virtual]`

  | A method that tests whether a string matches this argument. This is generally called by the processArg() method. This method could be re-implemented by a child to change how arguments are specified on the command line. Parameters:
  | s | - The string to be compared to the flag/name to determine whether the arg matches.
Definition at line 570 of file Arg.h. References _flag. Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiSwitchArg::processArg(), and TCLAP::MultiArg< T >::processArg().

void TCLAP::Arg::beginIgnoring | ( |  | ) | `[inline, static]`

| Begin ignoring arguments since the "--" argument was specified. Definition at line 191 of file Arg.h.

char TCLAP::Arg::blankChar | ( |  | ) | `[inline, static]`

| The char used as a place holder when SwitchArgs are combined. Currently set to the bell char (ASCII 7). Definition at line 208 of file Arg.h.

char TCLAP::Arg::delimiter | ( |  | ) | `[inline, static]`

| The delimiter that separates an argument flag/name from the value. Definition at line 202 of file Arg.h.

char TCLAP::Arg::flagStartChar | ( |  | ) | `[inline, static]`

| The char that indicates the beginning of a flag. Currently '-'. Definition at line 213 of file Arg.h. Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

const std::string TCLAP::Arg::flagStartString | ( |  | ) | `[inline, static]`

| The sting that indicates the beginning of a flag. Currently "-". Should be identical to flagStartChar. Definition at line 219 of file Arg.h.

void TCLAP::Arg::forceRequired | ( |  | ) | `[inline]`

| Sets _required to true. This is used by the XorHandler. You really have no reason to ever use it. Definition at line 630 of file Arg.h. References _required.

std::string TCLAP::Arg::getDescription | ( |  | ) | const`[inline]`

| Returns the argument description. Definition at line 534 of file Arg.h. References _requireLabel. Referenced by TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::UnlabeledMultiArg< T >::operator==(), TCLAP::DocBookOutput::printLongArg(), and TCLAP::ZshCompletionOutput::printOption().

const std::string & TCLAP::Arg::getFlag | ( |  | ) | const`[inline]`

| Returns the argument flag. Definition at line 547 of file Arg.h. Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

const std::string & TCLAP::Arg::getName | ( |  | ) | const`[inline]`

| Returns the argument name. Definition at line 549 of file Arg.h. Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::UnlabeledMultiArg< T >::operator==(), TCLAP::ZshCompletionOutput::printArg(), TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

const std::string TCLAP::Arg::ignoreNameString | ( |  | ) | `[inline, static]`

| The name used to identify the ignore rest argument. Definition at line 230 of file Arg.h. Referenced by Arg().

bool TCLAP::Arg::ignoreRest | ( |  | ) | `[inline, static]`

| Whether to ignore the rest. Definition at line 196 of file Arg.h.

bool TCLAP::Arg::isIgnoreable | ( |  | ) | const`[inline]`

| Indicates whether the argument can be ignored, if desired. Definition at line 563 of file Arg.h.

bool TCLAP::Arg::isRequired | ( |  | ) | const`[inline, virtual]`

| Indicates whether the argument is required. Reimplemented in TCLAP::MultiArg< T >. Definition at line 551 of file Arg.h. Referenced by TCLAP::CmdLine::add(), TCLAP::XorHandler::check(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

bool TCLAP::Arg::isSet | ( |  | ) | const`[inline]`

| Indicates whether the argument has already been set. Only true if the arg has been matched on the command line. Definition at line 555 of file Arg.h. References _alreadySet.

bool TCLAP::Arg::isValueRequired | ( |  | ) | const`[inline]`

| Indicates whether a value must be specified for argument. Definition at line 553 of file Arg.h. Referenced by TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

std::string TCLAP::Arg::longID | ( | const std::string & | valueId = `"val"` | ) | const`[inline, virtual]`

  | Returns a long ID for the usage. Parameters:
  | valueId | - The value used in the id.
Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >. Definition at line 503 of file Arg.h. References _flag. Referenced by TCLAP::CmdLine::add().

const std::string TCLAP::Arg::nameStartString | ( |  | ) | `[inline, static]`

| The sting that indicates the beginning of a name. Currently "--". Should be flagStartChar twice. Definition at line 225 of file Arg.h. Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

bool TCLAP::Arg::operator== | ( | const Arg & | a | ) | const`[inline, virtual]`

  | Operator ==. Equality operator. Must be virtual to handle unlabeled args. Parameters:
  | a | - The Arg to be compared to this.
Reimplemented in TCLAP::UnlabeledMultiArg< T >, and TCLAP::UnlabeledValueArg< T >. Definition at line 526 of file Arg.h. References _flag, and _name.

virtual bool TCLAP::Arg::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) | `[pure virtual]`

  | Pure virtual method meant to handle the parsing and value assignment of the string on the command line. Parameters:
  | i | - Pointer the the current argument in the list.
  | args | - Mutable list of strings. What is passed in from main.
Implemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::SwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >.

void TCLAP::Arg::reset | ( |  | ) | `[inline, virtual]`

| Clears the Arg object and allows it to be reused by new command lines. Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::SwitchArg, and TCLAP::ValueArg< T >. Definition at line 659 of file Arg.h. References _alreadySet, and _xorSet.

void TCLAP::Arg::setDelimiter | ( | char | c | ) | `[inline, static]`

  | Sets the delimiter for all arguments. Parameters:
  | c | - The character that delimits flags/names from values.
Definition at line 236 of file Arg.h.

void TCLAP::Arg::setRequireLabel | ( | const std::string & | s | ) | `[inline]`

  | Sets the requireLabel. Used by XorHandler. You shouldn't ever use this. Parameters:
  | s | - Set the requireLabel to this value.
Definition at line 565 of file Arg.h. References _requireLabel.

std::string TCLAP::Arg::shortID | ( | const std::string & | valueId = `"val"` | ) | const`[inline, virtual]`

  | Returns a short ID for the usage. Parameters:
  | valueId | - The value used in the id.
Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >. Definition at line 485 of file Arg.h. References _flag. Referenced by TCLAP::DocBookOutput::printLongArg(), TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

std::string TCLAP::Arg::toString | ( |  | ) | const`[inline, virtual]`

| Returns a simple string representation of the argument. Primarily for debugging. Definition at line 579 of file Arg.h. References _flag, and _name. Referenced by TCLAP::ValueArg< T >::_extractValue(), TCLAP::MultiArg< T >::_extractValue(), Arg(), TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), and TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg().

void TCLAP::Arg::trimFlag | ( | std::string & | flag,
|  | std::string & | value
| ) | const`[inline, virtual]`

  | Implementation of trimFlag. Parameters:
  | flag | - The string from which the flag and value will be trimmed. Contains the flag once the value has been trimmed.
  | value | - Where the value trimmed from the string will be stored.
Definition at line 600 of file Arg.h. Referenced by TCLAP::ValueArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

void TCLAP::Arg::xorSet | ( |  | ) | `[inline]`

| Sets the _alreadySet value to true. This is used by the XorHandler. You really have no reason to ever use it. Definition at line 635 of file Arg.h. References _alreadySet, and _xorSet.

## Member Data Documentation

bool TCLAP::Arg::_acceptsMultipleValues`[protected]`

| Definition at line 149 of file Arg.h.

bool TCLAP::Arg::_alreadySet`[protected]`

| Indicates whether the argument has been set. Indicates that a value on the command line has matched the name/flag of this argument and the values have been set accordingly. Definition at line 128 of file Arg.h. Referenced by isSet(), reset(), and xorSet().

std::string TCLAP::Arg::_description`[protected]`

| Description of the argument. Definition at line 103 of file Arg.h.

std::string TCLAP::Arg::_flag`[protected]`

| The single char flag used to identify the argument. This value (preceded by a dash {-}), can be used to identify an argument on the command line. The _flag can be blank, in fact this is how unlabeled args work. Unlabeled args must override appropriate functions to get correct handling. Note that the _flag does NOT include the dash as part of the flag. Definition at line 89 of file Arg.h. Referenced by Arg(), argMatches(), longID(), operator==(), shortID(), and toString().

bool TCLAP::Arg::_ignoreable`[protected]`

| Whether this argument can be ignored, if desired. Definition at line 141 of file Arg.h.

std::string TCLAP::Arg::_name`[protected]`

| A single work namd indentifying the argument. This value (preceded by two dashed {--}) can also be used to identify an argument on the command line. Note that the _name does NOT include the two dashes as part of the _name. The _name cannot be blank. Definition at line 98 of file Arg.h. Referenced by Arg(), operator==(), and toString().

bool TCLAP::Arg::_required`[protected]`

| Indicating whether the argument is required. Definition at line 108 of file Arg.h. Referenced by forceRequired().

std::string TCLAP::Arg::_requireLabel`[protected]`

| Label to be used in usage description. Normally set to "required", but can be changed when necessary. Definition at line 114 of file Arg.h. Referenced by getDescription(), and setRequireLabel().

bool TCLAP::Arg::_valueRequired`[protected]`

| Indicates whether a value is required for the argument. Note that the value may be required but the argument/value combination may not be, as specified by _required. Definition at line 121 of file Arg.h.

Visitor* TCLAP::Arg::_visitor`[protected]`

| A pointer to a vistitor object. The visitor allows special handling to occur as soon as the argument is matched. This defaults to NULL and should not be used unless absolutely necessary. Definition at line 136 of file Arg.h. Referenced by _checkWithVisitor().

bool TCLAP::Arg::_xorSet`[protected]`

| Indicates that the arg was set as part of an XOR and not on the command line. Definition at line 147 of file Arg.h. Referenced by reset(), and xorSet().

The documentation for this class was generated from the following file:

- Arg.h